#!/usr/bin/ruby -Ks
require 'chain'

class ExceptionHandler
  def execute(c)
    puts 'Filter.execute'
  end
  def post_execute(cx, e)
    p e if !e.nil?
  end
end

class GetCustomerInfo
  def execute(c)
    c.customer_name = 'Foo the Man'
    puts 'GetCustomerInfo'
  end
end

class TestDriveVehicle
  def execute(c)
    puts 'TestDriveVehicle'
  end
end

class NegotiateSale
  def execute(c)
    puts 'NegotiateSale'
  end
end

class CloseSale
  def execute(c)
    puts 'CloseSale'
    true
  end
end

class ArrangeFinancing
  def execute(c)
    raise RuntimeError, c.customer_name + ' is blacklisted'
  end
end

class Context < Hash
  def initialize()
    @customer_name = nil
  end
  attr_accessor :customer_name
end

if $0 == __FILE__
  c = Catalog.load_catalog('config.rb')
  chain = c.get_chain("sell-vehicle")
  chain.execute(Context.new)
end

